com.pixelmed.dose

## Class DeviceParticipant

- java.lang.Object
- - com.pixelmed.dose.DeviceParticipant

-     public class DeviceParticipant
      extends java.lang.Object

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.lang.String` | `manufacturer`
    `protected java.lang.String` | `modelName`
    `protected java.lang.String` | `serialNumber`
    `protected java.lang.String` | `uid`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DeviceParticipant(ContentItem parent)`
    `DeviceParticipant(java.lang.String manufacturer, java.lang.String modelName, java.lang.String serialNumber)` Deprecated. will create SR template missing Device Observer UID since CP 1065 added it as mandatory (000653)
    `DeviceParticipant(java.lang.String manufacturer, java.lang.String modelName, java.lang.String serialNumber, java.lang.String uid)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static java.lang.String` | `getDeviceObserverUIDOrSuitableAlternative(AttributeList list)` Extract the device observer UID information from a list of attributes, or some suitable alternate if available.
    `static java.lang.String` | `getDeviceSerialNumberOrSuitableAlternative(AttributeList list, boolean insertAlternateBackInList)` Extract the device serial number information from a list of attributes, or some suitable alternate if available.
    `java.lang.String` | `getManufacturer()`
    `java.lang.String` | `getModelName()`
    `java.lang.String` | `getSerialNumber()`
    `ContentItem` | `getStructuredReportFragment()`
    `java.lang.String` | `getUID()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### manufacturer

          protected java.lang.String manufacturer

    - #### modelName

          protected java.lang.String modelName

    - #### serialNumber

          protected java.lang.String serialNumber

    - #### uid

          protected java.lang.String uid

  - ### Constructor Detail

    - #### DeviceParticipant

          public DeviceParticipant(java.lang.String manufacturer,
                                   java.lang.String modelName,
                                   java.lang.String serialNumber)

      Deprecated. will create SR template missing Device Observer UID since CP 1065 added it as mandatory (000653)

    - #### DeviceParticipant

          public DeviceParticipant(java.lang.String manufacturer,
                                   java.lang.String modelName,
                                   java.lang.String serialNumber,
                                   java.lang.String uid)

    - #### DeviceParticipant

          public DeviceParticipant(ContentItem parent)

  - ### Method Detail

    - #### getManufacturer

          public java.lang.String getManufacturer()

    - #### getModelName

          public java.lang.String getModelName()

    - #### getSerialNumber

          public java.lang.String getSerialNumber()

    - #### getUID

          public java.lang.String getUID()

    - #### getStructuredReportFragment

          public ContentItem getStructuredReportFragment()
                                                  throws DicomException

      Throws:
        `DicomException`

    - #### getDeviceSerialNumberOrSuitableAlternative

          public static java.lang.String getDeviceSerialNumberOrSuitableAlternative(AttributeList list,
                                                                                    boolean insertAlternateBackInList)

      Extract the device serial number information from a list of attributes, or some suitable alternate if available.

      Makes a hash of StationName and Institution as an alternate, if either or both present and not empty.

      Parameters:
        `list` - the list of attributes
        `insertAlternateBackInList` - if true, when there is no DeviceSerialNumber or it is empty, add the alterate created back to the supplied list (side effect of call)
      Returns:
        a string containing either the DeviceSerialNumber from the list or a suitable alternate if available, else null

    - #### getDeviceObserverUIDOrSuitableAlternative

          public static java.lang.String getDeviceObserverUIDOrSuitableAlternative(AttributeList list)

      Extract the device observer UID information from a list of attributes, or some suitable alternate if available.

      Makes a hash of DeviceSerialNumber, StationName, Institution, Manufacturer, Manufacturer Model Name as an alternate, if any are present and not empty.

      Parameters:
        `list` - the list of attributes
      Returns:
        a string containing a suitable UID if available, else null